.386
.model flat, stdcall
option casemap:none

include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc
include	\masm32\include\user32.inc

include	PEmem.inc                             ; function prototypes for PEmem.lib

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib

includelib  lib\PEmem.lib

EXTERN      pEXE:BYTE                             ; pointer to Dialog.exe
                                                  ; linked  to the main executable

.data

message1    db 'Ready to test PE from memory...',0
message2    db 'Testing finished.',0
title1      db 'Portable executable from memory',0
errmessage  db 'PE loading failure',0
caption     db 'Error',0

.data?

hVirtModule dd ?                                  ; handle to the "virtual" module Dialog.exe

.code

start:

    invoke  MessageBox,0,ADDR message1,ADDR title1,MB_OK
    invoke  LoadEXEfromMem,ADDR pEXE,ADDR hVirtModule

    or      eax,eax                               ; check the value of entry point
    jnz     @f                                    ; returned by eax
    
    invoke  MessageBox,0,ADDR errmessage,ADDR caption,MB_ICONERROR
    jmp     finish
                                                  
@@:

    call    eax                                   ; call the PE
                                                  ; embedded in our main executable PEmem

    invoke  MessageBox,0,ADDR message2,ADDR title1,MB_OK

finish:   

    invoke  FreeEXEfromMem,hVirtModule            ; Release the memory allocated
                                                  ; for Dialog.exe

    invoke  ExitProcess,0

END start     