; GetProcAddr by Vortex
; Many thanks to Hutch for his szCmp procedure 

.386
.model flat, stdcall
option casemap:none

GetProcAddr	PROTO :DWORD,:DWORD

include	\masm32\include\windows.inc
include	\masm32\include\kernel32.inc

.code

GetProcAddr PROC uses esi edi ebx hModule:DWORD,func:DWORD

LOCAL hMod:DWORD,tempvar:DWORD,NameNumb:DWORD,counter:DWORD

    mov	counter,0
    mov	edi,hModule
    ASSUME	edi:ptr IMAGE_DOS_HEADER
    add	edi,[edi].e_lfanew
    ASSUME	edi:ptr IMAGE_NT_HEADERS
    mov	edi,[edi].OptionalHeader.DataDirectory.VirtualAddress
    add	edi,hModule
    mov	ebx,edi
    
    ASSUME	edi:ptr IMAGE_EXPORT_DIRECTORY
    ASSUME	ebx:ptr IMAGE_EXPORT_DIRECTORY
    
    mov	eax,[edi].NumberOfNames
    mov	NameNumb,eax
    mov	esi,[edi].AddressOfNames
    add	esi,hModule

    .WHILE	NameNumb>0
        mov	edi,[esi]
        add	edi,hModule

            push esi    ; szCmp function from Hutch's Masm32 package
            mov ecx, edi
            mov edx, func
            xor esi, esi
    cmst:
            mov al, [ecx+esi]
            cmp al, [edx+esi]
            jne no_match
            add esi, 1
            test al, al         ; check for terminator
            jne cmst

            xor eax,eax
            inc eax             ; return TRUE on match
            jmp cmpout

    no_match:
            xor eax, eax        ; return zero on no match

    cmpout:
            pop esi             ; end of szCmp

        or	eax,eax
        jz	notfound
        mov	esi,[ebx].AddressOfNameOrdinals          
        mov	ecx,counter
        shl	ecx,1
        add	esi,ecx 
        add	esi,hModule
        xor	eax,eax
        mov	ax,WORD PTR [esi]
        shl	eax,2
        mov	esi,[ebx].AddressOfFunctions
        add	esi,hModule
        add	esi,eax	
        mov	edi,[esi]
        add	edi,hModule
        mov	eax,edi
        ret		
        .BREAK
notfound:		
        inc	counter
        dec	NameNumb
        add	esi,4
    .ENDW

    xor eax,eax
    ret

GetProcAddr ENDP

END