; Many thanks to Chetnik for his do_relocation procedure

.386
.model flat, stdcall
option casemap:none

do_relocation   PROTO :DWORD,:DWORD,:DWORD

include         \masm32\include\windows.inc
include         \masm32\include\kernel32.inc

.code

do_relocation PROC reloc_P:DWORD,exefileptr:DWORD,nthdr:DWORD

    LOCAL relocation:DWORD
    mov eax, exefileptr
    mov edx,nthdr
    ASSUME  edx:ptr IMAGE_NT_HEADERS32
    mov ecx, [edx].OptionalHeader.ImageBase
    sub eax, ecx
    mov relocation, eax
    
    mov ebx, reloc_P
    ASSUME ebx : ptr IMAGE_BASE_RELOCATION

@relocs: 

    mov ecx, [ebx].SizeOfBlock
    sub ecx, 8               ;<---- chunsize - sizeof IMAGE_RELOC which is 8
    shr ecx, 1               ;<---- divide by 1^2 aka 2 
    
    mov edx, [ebx].VirtualAddress
    add edx, exefileptr          ;<---- here is base for this allocation!!!!

@@:                              ;<---- ecx holds number of relocations

    mov edi, edx
    xor eax, eax
    mov ax, word ptr[ebx+8+ecx*2-2]   ;<---- starts from last chunk
                                      ;<---- Assume that all chunks are relocateable
                                      ; ecx is one step ahead so we need -2 =))
                                      ;<---- is this 3 or 0?!?!?!
    push edx
    xor edx, edx
    mov dx, ax
    shr dx, 12         
    cmp edx, 0
    jz @skip                          ;<--- if 0 skip relocation job                                           
    and ax, 0FFFh                     
    add edi, eax                      ;<---- here should be first relocation!!!
    mov eax, [edi]                    ;<---- get that value
    add eax, relocation               ;<---- do relocation
    stosd                             ;<---- put relocataed value back!!!

@skip:

    pop edx                           ;<---- restore edx
    loop @B                                               
    add ebx, [ebx].SizeOfBlock
    cmp [ebx].VirtualAddress, NULL    ;<---- end of relocation???
    jnz   @relocs
    ret
do_relocation ENDP

END